﻿// ver3.0

// グローバル宣言
// 変数
var objAllInfo;

// classの設定

// 全体情報管理クラス
var clsAllInfo
 = function ()
{
  // メンバ変数の定義と初期化
  // 情報内部保持変数
  this.intSeiryoku = [-1, -1];    // 勢力選択
  this.intSenjou = [-1, -1, -1];     // 戦場選択
  this.intJikanShubetu = -1;     // 時間種別選択
  this.intBshou = [ [-1, -1], [-1, -1], [-1, -1] ];     // 武将選択


  // リテラル名文字列配列
  this.arySeiryoku = ["魏", "呉", "蜀"];
  this.arySenjou = ["河畔・弐", "河畔・参", "草原", "渓谷", "関"];
  this.aryJinei = [["南西", "北"]
                  ,["北", "南東"]
                  ,["西", "東"]
                  ,["東", "西"]
                  ,["東", "西"]];
  this.aryKaisiJikan = ["２０：００", "２１：３０"];
  this.aryJikanShubetu = ["同時", "時間差", "特殊"];
  this.aryStrBshou = [ ["曹操", "孫権", "劉備"]
                     , ["夏侯惇", "孫策", "関羽"]
                     , ["張遼", "周瑜", "張飛"]
                     , ["夏侯淵", "甘寧", "趙雲"]
                     , ["許楮", "陸遜", "諸葛亮"]
                     , ["徐晃", "太史慈", "馬超"]
                     , ["司馬懿", "孫尚香", "黄忠"] ]

  // フォーム部品の参照簡略化オブジェクト
  this.objSelectSeiryoku   = [document.getElementById("seiryoku1")
                            , document.getElementById("seiryoku2")];
  this.objSelectSenjou     = [document.getElementById("jin1")
                            , document.getElementById("jin2")
                            , document.getElementById("jin3")];
  this.objStrJikan         = document.getElementById("strJikan");
  this.objBtnChngJikan     = document.getElementById("btnChngJikan");
  this.objSlctJikan        = document.getElementById("slctJikan");
  this.objSlctJikanShubetu = document.getElementById("slctJikanShubetu");
  this.objSelectBushou   = [ [document.getElementById("bushouJ1S1"), document.getElementById("bushouJ1S2")]
                           , [document.getElementById("bushouJ2S1"), document.getElementById("bushouJ2S2")]
                           , [document.getElementById("bushouJ3S1"), document.getElementById("bushouJ3S2")] ];

  // 表示テーブルオブジェクト
  
  this.objStrLbl       = [document.getElementById("lblSeiryoku1")
                        , document.getElementById("lblSeiryoku2")];
  this.objStrLblInfo   = [ [document.getElementById("lblJinInfoJ1S1"), document.getElementById("lblJinInfoJ1S2")]
                        ,  [document.getElementById("lblJinInfoJ2S1"), document.getElementById("lblJinInfoJ2S2")]
                        ,  [document.getElementById("lblJinInfoJ3S1"), document.getElementById("lblJinInfoJ3S2")] ];
  this.objStrLblBushou = [ [document.getElementById("lblJinBushouJ1S1"), document.getElementById("lblJinBushouJ1S2")]
                        ,  [document.getElementById("lblJinBushouJ2S1"), document.getElementById("lblJinBushouJ2S2")]
                        ,  [document.getElementById("lblJinBushouJ3S1"), document.getElementById("lblJinBushouJ3S2")] ];


  this.objTblKekka = document.getElementById("tblKekka");
  this.objStrLblKekka = [ document.getElementById("lblStrKekka1"), document.getElementById("lblStrKekka2") ];


  // メンバ関数の定義
  // 初期化、コンストラクト
  this.Init
  = function()
  {

    // 勢力１の選択欄を初期化
    this.setSeiryokuSelectBox(-1);
    
 
    // 陣１の選択欄を初期化
    this.setSenjouSelectBox(-1);

    // 開始時間の選択欄を初期化
    this.setJikanSelectBox();

    // 時間種別の選択欄を初期化
    this.setJikanShubetuSelectBox();

  }

  // 勢力選択項目の設定
  this.setSeiryokuSelectBox
   = function(intSelectedItemNum)
    {
      // 選択項目の情報をセット
      if(intSelectedItemNum > -1)
      {
        this.intSeiryoku[intSelectedItemNum] = this.objSelectSeiryoku[intSelectedItemNum].options[this.objSelectSeiryoku[intSelectedItemNum].selectedIndex].value;
        this.objStrLbl[intSelectedItemNum].innerText = this.arySeiryoku[this.intSeiryoku[intSelectedItemNum]] + "側";
      }

      //後の項目を設定
      for(intI = intSelectedItemNum + 1; intI < this.intSeiryoku.length; intI++)
      {
        this.intSeiryoku[intI] = -1;
        this.objStrLbl[intI].innerText = "未選択";
        this.objSelectSeiryoku[intI].options.length = 0;

        // 次の項目は勢力情報をセットする
        if(intI == intSelectedItemNum + 1)
        {
          for(intS = 0; intS < this.arySeiryoku.length; intS++)
          { //alert(this.intSeiryoku);
            var bSetOk = true;
            for(intTmp = 0; intTmp < this.intSeiryoku.length; intTmp++)
            {
            //alert(intI + "," + intS + "," + intTmp + "," + this.intSeiryoku[intTmp]);
              if(intS == this.intSeiryoku[intTmp])
              {
                bSetOk = false;
              }
            }
            if(bSetOk)
            {
              this.objSelectSeiryoku[intSelectedItemNum +1].options.length++;
              this.objSelectSeiryoku[intSelectedItemNum +1].options[this.objSelectSeiryoku[intSelectedItemNum +1].options.length - 1].value = intS;
              this.objSelectSeiryoku[intSelectedItemNum +1].options[this.objSelectSeiryoku[intSelectedItemNum +1].options.length - 1].label = this.arySeiryoku[intS];
            }
          }

        }
      }

    // 武将選択欄の初期化
    this.setBushouSelectBox(-1, intSelectedItemNum);

    }

  //戦場選択項目の設定
  this.setSenjouSelectBox
   = function(intSelectedItemNum)
    {
      // コピペ表示を初期化
      this.selectSeiryokuRec(-1);

      // 選択項目の情報をセット
      if(intSelectedItemNum > -1)
      {
        this.intSenjou[intSelectedItemNum] = this.objSelectSenjou[intSelectedItemNum].options[this.objSelectSenjou[intSelectedItemNum].selectedIndex].value;
        this.objStrLblInfo[intSelectedItemNum][0].innerText = this.arySenjou[this.intSenjou[intSelectedItemNum]] + this.aryJinei[this.intSenjou[intSelectedItemNum]][0];
        this.objStrLblInfo[intSelectedItemNum][1].innerText = this.arySenjou[this.intSenjou[intSelectedItemNum]] + this.aryJinei[this.intSenjou[intSelectedItemNum]][1];
      }

      if(intSelectedItemNum == this.objSelectSenjou.length -1)
      {
        return;
      }

      //後の項目を削除
      for(intI = intSelectedItemNum + 1; intI < this.intSenjou.length; intI++)
      {
        this.intSenjou[intI] = -1;
        this.objStrLblInfo[intI][0].innerText = "";
        this.objStrLblInfo[intI][1].innerText = "";
        if(intI != intSelectedItemNum + 1)
        {
          this.objSelectSenjou[intI].options.length = 0;
        }
      }

      // 選択した次の項目を設定する
      this.objSelectSenjou[intSelectedItemNum +1].options.length = 0;
      for(intI=0; intI < this.arySenjou.length; intI++)
      {
        var bSetOk = true;

        for(intJ = 0; intJ < this.intSenjou.length; intJ++)
        {
          if(intI == this.intSenjou[intJ])
          {
            bSetOk = false;
          }
        }

        if(bSetOk)
        {
          this.objSelectSenjou[intSelectedItemNum +1].options.length++;
          this.objSelectSenjou[intSelectedItemNum +1].options[this.objSelectSenjou[intSelectedItemNum +1].options.length - 1].value = intI;
          this.objSelectSenjou[intSelectedItemNum +1].options[this.objSelectSenjou[intSelectedItemNum +1].options.length - 1].label = this.arySenjou[intI];
        }
      }

    }


  //武将選択項目の設定
  this.setBushouSelectBox
   = function(intSelectJ, intSelectS)
    { //alert(intSelectJ + "," + intSelectS);

      // 初期化の場合
      if(intSelectS == -1)
      {
        for(intJ = 0; intJ < this.objSelectBushou.length; intJ++)
        {
          for(intS = 0; intS < this.objSelectBushou[intJ].length; intS++)
          {
            this.objSelectBushou[intJ][intS].options.length = 0;
            this.intBshou[intJ][intS] = -1;
          }
        }
      }
      else  // 初期化以外の場合は、選択項目の次を初期化
      {
        if(intSelectJ != -1)
        {
//          alert(this.objSelectBushou[intSelectJ][intSelectS].options[this.objSelectBushou[intSelectJ][intSelectS].selectedIndex].value);
          this.intBshou[intSelectJ][intSelectS]
            = this.objSelectBushou[intSelectJ][intSelectS].options[this.objSelectBushou[intSelectJ][intSelectS].selectedIndex].value;
          this.objStrLblBushou[intSelectJ][intSelectS].innerText = this.aryStrBshou[intSelectJ][intSelectS];
        }
        for(intJ = intSelectJ + 1; intJ < this.objSelectBushou.length; intJ++)
        {
          this.objSelectBushou[intJ][intSelectS].options.length = 0;
          this.intBshou[intJ][intSelectS] = -1;
          this.objStrLblBushou[intJ][intSelectS].innerText = "";
          if(intJ == intSelectJ + 1)
          {
            for(intB = 0; intB < this.aryStrBshou.length; intB++)
            {
              var bUpOk = true;
              for(intI = 0; intI < this.intBshou[intJ].length; intI++)
              {
                if(this.intBshou[intI][intSelectS] == intB)
                {
                  bUpOk = false;
                }
              }
              
              if(bUpOk)
              {
                this.objSelectBushou[intJ][intSelectS].options.length++;
                this.objSelectBushou[intJ][intSelectS].options[this.objSelectBushou[intJ][intSelectS].options.length - 1].value = intB;
                this.objSelectBushou[intJ][intSelectS].options[this.objSelectBushou[intJ][intSelectS].options.length - 1].label = this.aryStrBshou[intB][this.intSeiryoku[intSelectS]];
              }
            }
          }
        }

      }
      // コピペ表示を初期化
      this.selectSeiryokuRec(-1);

    }


  // 開始時間選択項目の設定
  this.setJikanSelectBox
   = function(intSelectedItemNum)
    {
      this.objStrJikan.value = "";
      this.objSlctJikan.options.length = this.aryKaisiJikan.length;
      for(intI = 0; intI < this.aryKaisiJikan.length; intI++)
      {
        this.objSlctJikan.options[intI].value = intI;
        this.objSlctJikan.options[intI].label = this.aryKaisiJikan[intI];
      }
      // コピペ表示を初期化
      this.selectSeiryokuRec(-1);

    }

  // 時間種別選択項目の設定
  this.setJikanShubetuSelectBox
   = function(intSelectedItemNum)
    {
      this.objSlctJikanShubetu.options.length = this.aryJikanShubetu.length;
      for(intI = 0; intI < this.aryJikanShubetu.length; intI++)
      {
        this.objSlctJikanShubetu.options[intI].value = intI;
        this.objSlctJikanShubetu.options[intI].label = this.aryJikanShubetu[intI];
      }
    }


  // イベントはんどら系
  // 開始時間を選択したとき
  this.setStrJin
   = function(intSelectedItemNum)
    {
      this.objStrJikan.value = this.objSlctJikan.options[this.objSlctJikan.selectedIndex].label;
      this.objSlctJikan.style.visibility = "hidden";
      this.objBtnChngJikan.value = "▼";
      
      // コピペ表示を初期化
      this.selectSeiryokuRec(-1);
    }

  // 表示テーブルをクリックしたとき
  this.selectSeiryokuRec
   = function(intSelectedItemNum)
    {
      var strTaisen = ["", ""];
      var aryTmp = new Array();
      var bUpOk = true;

      // まずは初期化
      this.objStrLblKekka[0].innerText = "";
      this.objStrLblKekka[1].innerText = "";

      // 全部選んでない場合は、するーして、表示してるのを消しておく
      if( (intSelectedItemNum == -1)
       || (this.intSeiryoku[this.intSeiryoku.length - 1] == -1)
       || (this.intSenjou[this.intSenjou.length - 1] == -1)
       || (this.objStrJikan.value.length < 1)
       || (this.intJikanShubetu == -1) )
      {
        return;
      }

      // テーブルの行の背景色を初期化
      for(var i=1; i < this.objTblKekka.rows.length; i++)
      {
        this.objTblKekka.rows[i].style.backgroundColor = "";
      }
      // 選択した行は色をつけておく
      this.objTblKekka.rows[intSelectedItemNum].style.backgroundColor = "#d0aaaa";


      // 選択勢力用のチャットなんかで流すと便利な文字列を作っておく
      // まずは、～対　とか　対～　の表示を設定
      aryTmp.length = 0;
      for(intS = 0; intS < this.intSeiryoku.length; intS++)
      {
        aryTmp.length++;
        aryTmp[aryTmp.length - 1] = this.arySeiryoku[this.intSeiryoku[intS]];
      }
      aryTmp[intSelectedItemNum - 1] = "";
//      strTaisen[0] = aryTmp.join("対") + " ";

      // 時間関係の設定
//      strTaisen = strTaisen + this.objStrJikan.value +  "～ ";
//      strTaisen = strTaisen + this.aryJikanShubetu[this.intJikanShubetu];
      
      // 各陣の戦場と方角を設定
      for(intJ = 0; intJ < this.intBshou.length; intJ++)
      {
        var strTmp = "";
        strTmp = " " +  this.arySenjou[this.intSenjou[intJ]];
        strTmp = strTmp +   this.aryJinei[this.intSenjou[intJ]][intSelectedItemNum - 1];
        strTaisen[0] = strTaisen[0] + strTmp;
        if(this.intBshou[intJ][intSelectedItemNum - 1] == -1)
        {
          bUpOk = false;
        }
        else
        {
          strTaisen[1] = strTaisen[1] + strTmp + "：" + this.aryStrBshou[this.intBshou[intJ][intSelectedItemNum - 1]][this.intSeiryoku[intSelectedItemNum - 1]];
        }
      }


      // 武将名なしバージョンを表示
      this.objStrLblKekka[0].innerText = aryTmp.join("対") + " "
                                       + this.objStrJikan.value +  "～ "
                                       + this.aryJikanShubetu[this.intJikanShubetu]
                                       + strTaisen[0];
      if(bUpOk)
      {
        this.objStrLblKekka[1].innerText = aryTmp.join("対") + " "
                                         + this.objStrJikan.value +  "～ "
                                         + this.aryJikanShubetu[this.intJikanShubetu]
                                         + strTaisen[1];
      }

/*
      // 武将も設定されているなら、武将も追加して表示
      // 処理的には武将名を付け足すところが増えてるだけ、無駄なループだよね＾＾；；；
      for(intJ = 0; intJ < this.intBshou.length; intJ++)
      {
        if(this.intBshou[intJ][this.intBshou[intJ].length - 1] == -1)
        {
          bUpOk = false;
        }
      }
      
      if(bUpOk)
      {
        strTaisen = aryTmp.join("対") + " "  +  this.objStrJikan.value +  "～ ";
        strTaisen = strTaisen +  this.aryJikanShubetu[this.intJikanShubetu];
        for(intJ = 0; intJ < this.intBshou.length; intJ++)
        {
          strTaisen = strTaisen +   " " +  this.arySenjou[this.intSenjou[intJ]];
          strTaisen = strTaisen +   this.aryJinei[this.intSenjou[intJ]][intSelectedItemNum - 1] +  "：";
          strTaisen = strTaisen +   this.aryStrBshou[this.intBshou[intJ][intSelectedItemNum - 1]][this.intSeiryoku[intSelectedItemNum - 1]];
        }
        this.objStrLblKekka[1].innerText = strTaisen;
      }
*/
    }

}

/*


*/

  // ＨＴＭＬ側のイベントハンドラ

  // 初期化処理
  function onInit()
  {
    objAllInfo = new clsAllInfo();
    objAllInfo.Init();
  }



  // 勢力１を変更したらそれ以外で勢力２の選択項目を設定する
  function setSeiryoku1()
  {
    objAllInfo.setSeiryokuSelectBox(0);
  }

  // 勢力２を選択したら下の表に表示する
  function setSeiryoku2()
  {
    objAllInfo.setSeiryokuSelectBox(1);
  }



  // １陣を変更したら１陣で選択したもの以外で２陣の選択項目を設定する
  function setJin1()
  {
    objAllInfo.setSenjouSelectBox(0);
  }

  // ２陣を変更したら１陣と２陣で選択したもの以外で３陣の選択項目を設定する
  function setJin2()
  {
    objAllInfo.setSenjouSelectBox(1);
  }

  // ３陣を変更したら下に表示する
  function setJin3()
  {
    objAllInfo.setSenjouSelectBox(2);
  }


  // 開始時間の選択ボタン押したとき
  function changeJikanSelect()
  {
    if(objAllInfo.objBtnChngJikan.value=="▼")
    {
      objAllInfo.objSlctJikan.style.visibility = "visible";
      objAllInfo.objBtnChngJikan.value = "▲";
    }
    else
    {
      objAllInfo.objSlctJikan.style.visibility = "hidden";
      objAllInfo.objBtnChngJikan.value = "▼";
    }
  
  }

  // 開始時間を選択したとき
  function setStrJin()
  {
    objAllInfo.setStrJin();
  }

  // 時間種別を選択したとき
  function setJikanShubetu()
  {
    objAllInfo.intJikanShubetu = objAllInfo.objSlctJikanShubetu.options[objAllInfo.objSlctJikanShubetu.options.selectedIndex].value;
    // コピペ表示を初期化
    objAllInfo.selectSeiryokuRec(-1);
  }

  // 武将を選択したとき
  function setBushouSelectBox(intSelectJ, intSelectS)
  {
    objAllInfo.setBushouSelectBox(intSelectJ, intSelectS);
  }

  // とりあえず何もしない関数、後で入れるよーって書いておくスタブ関数の呼び出し先
  function stb()
  {
  }


  //行（勢力）選択
  function selectSeiryokuRec(iSeiryoku)
  {
    objAllInfo.selectSeiryokuRec(iSeiryoku);
  }


